using UnityEngine;

namespace CheesyFX
{
    public class CapsulePenetrator : Penetrator
    {
        private CapsuleCollider capsule;

        public CapsulePenetrator Init(CapsuleCollider capsule)
        {
            base.Init(capsule);
            // capsule.Print();
            this.capsule = capsule;
            SetTip();
            return this;
        }

        public void SetTip()
        {
            switch (capsule.direction)
            {
                case 0:
                    tip.localPosition = new Vector3(0f,capsule.radius * scale,0f);
                    width = (capsule.height * .5f + capsule.radius) * scale*9f;
                    break;
                case 1:
                    tip.localPosition = new Vector3(0f,capsule.radius * scale,0f);
                    width = (capsule.height * .5f + capsule.radius) * scale*9f;
                    break;
                case 2:
                    tip.localPosition = new Vector3(capsule.radius * scale, 0f, 0f);
                    width = capsule.radius * scale*9f;
                    break;
            }
        }
    }
}