using System;
using System.Collections;
using UnityEngine;

namespace CheesyFX
{
    public class Penetrator : MonoBehaviour
    {
        public Transform tip;
        public Rigidbody rb;
        public Atom atom;
        public float scale;
        public float width;
        public bool isPenetrating;

        public Penetrator Init(Collider collider)
        {
            rb = collider.attachedRigidbody;
            atom = collider.GetAtom();
            tip = new GameObject().transform;
            tip.parent = collider.transform;
            return this;
        }

        private void GetScale()
        {
            if (scale == atom.scaleChangeReceivers[0].scale) return;
            scale = atom.scaleChangeReceivers[0].scale;
            if (this is CapsulePenetrator)
            {
                ((CapsulePenetrator)this).SetTip();
                foreach (var orifice in FillMeUp.orifices)
                {
                    if (orifice.penetratingAtom == atom) orifice.penetratorWidth = width;
                }
                // width.Print();
            }
        }

        public void Update()
        {
            if (!isPenetrating) return;
            GetScale();
        }
    }
}